//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2006, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+

#property copyright "(C) YuraZ Copyright 2006-2009 YZ_TRALL 20090309"
#property link      "yzh@mail.ru"


/*

       
    

          
           
       

     
   GBJPY  USDJPY   


   

  F3          SL 
  

              
          F3
    
  


*/

extern double pPIPslBU    =0.00050;      //      
extern double pPIPp       =0.00500;      //         -   

extern color cModifSell = Red;
extern color cModifBuy  = Red;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   BU();
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

static int FlagClose = 0;

void BU( )
  {

   int ErrCode;
   ErrCode=0;

   double lPIPslBU;
   double lPIPp;
   
   string Str = "";

   for(int l_pos_0=0; l_pos_0 < OrdersTotal(); l_pos_0++)
     {
      if (OrderSelect(l_pos_0, SELECT_BY_POS))
        {
            
            
            if ( GlobalVariableCheck("g"+OrderSymbol()+"_BU" ) == true ) //   
            {
                lPIPslBU = GlobalVariableGet("g"+OrderSymbol()+"_BU");
            }
            else
            {
                GlobalVariableSet("g"+OrderSymbol()+"_BU",pPIPslBU );
            }
            

            if ( GlobalVariableCheck("g"+OrderSymbol()+"_PIP" ) == true ) //           
            {
                lPIPp = GlobalVariableGet("g"+OrderSymbol()+"_PIP");
            }
            else
            {
                GlobalVariableSet("g"+OrderSymbol()+"_PIP",pPIPp );
            }

 
            if ( OrderType() == OP_SELL   )
            {
               Str = OrderSymbol()+" "+OrderProfit()+"\n"+Str;
               
               if ( OrderOpenPrice() - MarketInfo(  OrderSymbol() , MODE_ASK) >= lPIPp  && ( OrderOpenPrice() <= OrderStopLoss() || OrderStopLoss() == 0 ) )
                  OMODIF( OrderOpenPrice() - lPIPslBU ) ;

            }
            if ( OrderType() == OP_BUY  )
            {


               if ( MarketInfo(  OrderSymbol() , MODE_BID ) - OrderOpenPrice() >= lPIPp  && ( OrderOpenPrice() >= OrderStopLoss() || OrderStopLoss() == 0 ) )
                  OMODIF( OrderOpenPrice() +  lPIPslBU) ;

               Str = OrderSymbol()+" "+OrderProfit()+"\n"+Str;
 
            }
            
            
        }
     }

     /*
     if ( AccountProfit() >= mProfitCh )
     {
        FlagClose = 1;
        CloseALLOrder();
     }
     
     */

//     Comment( Str+" "+AccountBalance() +" "+AccountProfit()+" "+(AccountProfit()/(AccountBalance()/100)) );
  }

//+------------------------------------------------------------------+

void OMODIF( double MODIF)
{
   OrderModify( OrderTicket(), OrderOpenPrice(), MODIF , OrderTakeProfit(),0, cModifBuy  );
   int ErrCode=GetLastError();
   if (ErrCode!=0 )
   {
       Print( "***TRALL M ERROR  " + StringErrors(ErrCode) );
       Print( "***TRALL M ERROR  #"+OrderTicket()+" "+OrderOpenPrice()+" "+OrderTakeProfit()+" "+TimeToStr( OrderExpiration(),TIME_DATE|TIME_MINUTES|TIME_SECONDS));

   }
}


//+------------------------------------------------------------------+

string StringErrors(int ecode)
  {
   string STRRETURN;
   switch(ecode)
     {
      case        0: STRRETURN=ecode+"                                                     "; break;
      case        1: STRRETURN=ecode+"  ,                             "; break;
      case        2: STRRETURN=ecode+"                                                   "; break;
      case        3: STRRETURN=ecode+"                                         "; break;
      case        4: STRRETURN=ecode+"                                           "; break;
      case        5: STRRETURN=ecode+"                              "; break;
      case        6: STRRETURN=ecode+"                                     "; break;
      case        7: STRRETURN=ecode+"                                              "; break;
      case        8: STRRETURN=ecode+"                                          "; break;
      case        9: STRRETURN=ecode+"         "; break;
      case       64: STRRETURN=ecode+"                                              "; break;
      case       65: STRRETURN=ecode+"                                        "; break;
      case      128: STRRETURN=ecode+"                             "; break;
      case      129: STRRETURN=ecode+"                                              "; break;
      case      130: STRRETURN=ecode+"                                             "; break;
      case      131: STRRETURN=ecode+"                                             "; break;
      case      132: STRRETURN=ecode+"                                                   "; break;
      case      133: STRRETURN=ecode+"                                             "; break;
      case      134: STRRETURN=ecode+"                        "; break;
      case      135: STRRETURN=ecode+"                                                "; break;
      case      136: STRRETURN=ecode+"                                                        "; break;
      case      137: STRRETURN=ecode+"                                                   "; break;
      case      138: STRRETURN=ecode+"                                                     "; break;
      case      139: STRRETURN=ecode+"                           "; break;
      case      140: STRRETURN=ecode+"                                        "; break;
      case      141: STRRETURN=ecode+"                                          "; break;
      case      145: STRRETURN=ecode+"  ,         "; break;
      case      146: STRRETURN=ecode+"                                      "; break;
      case      147: STRRETURN=ecode+"             "; break;
      case      148: STRRETURN=ecode+"          "; break;

      case     4000: STRRETURN=ecode+"                                                    "; break;
      case     4001: STRRETURN=ecode+"                                 "; break;
      case     4002: STRRETURN=ecode+"   -                                "; break;
      case     4003: STRRETURN=ecode+"                                     "; break;
      case     4004: STRRETURN=ecode+"                     "; break;
      case     4005: STRRETURN=ecode+"                        "; break;
      case     4006: STRRETURN=ecode+"                              "; break;
      case     4007: STRRETURN=ecode+"                                  "; break;
      case     4008: STRRETURN=ecode+"                                   "; break;
      case     4009: STRRETURN=ecode+"                           "; break;
      case     4010: STRRETURN=ecode+"                                "; break;
      case     4011: STRRETURN=ecode+"                                         "; break;
      case     4012: STRRETURN=ecode+"                                       "; break;
      case     4013: STRRETURN=ecode+"                                                "; break;
      case     4014: STRRETURN=ecode+"                                           "; break;
      case     4015: STRRETURN=ecode+"                                          "; break;
      case     4016: STRRETURN=ecode+"                                   "; break;
      case     4017: STRRETURN=ecode+"  DLL                                       "; break;
      case     4018: STRRETURN=ecode+"                                "; break;
      case     4019: STRRETURN=ecode+"                                     "; break;
      case     4020: STRRETURN=ecode+"                  "; break;
      case     4021: STRRETURN=ecode+"    ,        "; break;
      case     4022: STRRETURN=ecode+"                                                "; break;
      case     4050: STRRETURN=ecode+"                      "; break;
      case     4051: STRRETURN=ecode+"                         "; break;
      case     4052: STRRETURN=ecode+"                             "; break;
      case     4053: STRRETURN=ecode+"                                                "; break;
      case     4054: STRRETURN=ecode+"   -                "; break;
      case     4055: STRRETURN=ecode+"                            "; break;
      case     4056: STRRETURN=ecode+"                                          "; break;
      case     4057: STRRETURN=ecode+"                         "; break;
      case     4058: STRRETURN=ecode+"                             "; break;
      case     4059: STRRETURN=ecode+"                            "; break;
      case     4060: STRRETURN=ecode+"                                        "; break;
      case     4061: STRRETURN=ecode+"                                          "; break;
      case     4062: STRRETURN=ecode+"    string                              "; break;
      case     4063: STRRETURN=ecode+"    integer                             "; break;
      case     4064: STRRETURN=ecode+"    double                              "; break;
      case     4065: STRRETURN=ecode+"                            "; break;
      case     4066: STRRETURN=ecode+"            "; break;
      case     4067: STRRETURN=ecode+"                          "; break;
      case     4099: STRRETURN=ecode+"                                                   "; break;
      case     4100: STRRETURN=ecode+"                                       "; break;
      case     4101: STRRETURN=ecode+"                                         "; break;
      case     4102: STRRETURN=ecode+"                                   "; break;
      case     4103: STRRETURN=ecode+"                                        "; break;
      case     4104: STRRETURN=ecode+"                              "; break;
      case     4105: STRRETURN=ecode+"                                          "; break;
      case     4106: STRRETURN=ecode+"                                            "; break;
      case     4107: STRRETURN=ecode+"                   "; break;
      case     4108: STRRETURN=ecode+"                                          "; break;
      case     4109: STRRETURN=ecode+"                                          "; break;
      case     4110: STRRETURN=ecode+"                                    "; break;
      case     4111: STRRETURN=ecode+"                                   "; break;
      case     4200: STRRETURN=ecode+"                                          "; break;
      case     4201: STRRETURN=ecode+"                          "; break;
      case     4202: STRRETURN=ecode+"                                           "; break;
      case     4203: STRRETURN=ecode+"                                        "; break;
      case     4204: STRRETURN=ecode+"                                              "; break;
      case     4205: STRRETURN=ecode+"                                       "; break;
      case     4206: STRRETURN=ecode+"                                    "; break;
      case     4207: STRRETURN=ecode+"                                     "; break;
      default:   STRRETURN=" ";

     }

   return(STRRETURN);
  }

